/******************************************************************************
 * debug.h
 *
 * Christophe BURNOTTE (2ELIN), Cyril SOLDANI (2ELIN),
 * Christophe XHROUET (2EN)
 *
 * Macros de dbogage.
 *****************************************************************************/

#ifndef _DEBUG_H_
#define _DEBUG_H_ "@(#)debug.h"

#ifdef DEBUG
/* DEBUG est dfinie : dfinit les macros de dbogage */

/* Imprime le message formatt spcifi sur la sortie standard, prcd du
 * fichier courant et du numro de ligne.
 * Arguments :
 * - format  : chane de formattage ;
 * - args... : arguments ventuels correspondant  la chane de formattage.
 * Valeur de retour : aucune. */
#define TRACE(format, args...) { \
printf("%s:%i: ", __FILE__, __LINE__); \
printf(format, ##args); \
fflush(stdout); \
}

/* Imprime le message formatt spcifi dans le flux donn, prcd du
 * fichier courant et du numro de ligne.
 * Arguments :
 * - stream  : flux dans lequel il faut crire le message ;
 * - format  : chane de formattage ;
 * - args... : arguments ventuels correspondant  la chane de formattage.
 * Valeur de retour : aucune. */
#define FTRACE(stream, format, args...) { \
fprintf(stream, "%s:%i: ", __FILE__, __LINE__); \
fprintf(stream, format, ##args); \
fflush(stdout); \
}

#else
/* DEBUG n'est pas dfinie : dsactive les macros de dbogage */

#define TRACE(format, args...)
#define FTRACE(stream, format, args...)

#endif

#endif
