/******************************************************************************
 * $Id: rand.c,v 1.1 2003/05/06 09:45:36 soldani Exp $
 *
 * BURNOTTE Christophe (2ELIN), SOLDANI Cyril (2ELIN), XHROUET Christophe (2EN)
 *
 * Gnrateur de nombres alatoires
 *****************************************************************************/

/* Graine */
static unsigned long next = 1;

/* Renvoie un nombre pseudo-alatoire compris entre 0 et 32767. La mthode
 * utilise est celle du gnrateur congruentiel linaire avec :
 * m = 32767
 * c = 12345
 * a = 1103515245 */
int getRand() {
  next = next * 1103515245 + 12345;
  return ((unsigned int) (next / 65536) % 32767);
}

/* Initialise la graine.
 * ENTRE:
 * - seed : valeur de la graine. */
void setSeed(unsigned int seed) {
  next = seed;
}
